"{ Package: 'jn:refactoring_custom' }"

CustomCodeGeneratorOrRefactoringTestCase subclass:#CustomTestCaseCodeGeneratorTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Generators-Tests'
!


!CustomTestCaseCodeGeneratorTests methodsFor:'accessing'!

generatorOrRefactoring
    ^CustomTestCaseCodeGenerator new
! !

!CustomTestCaseCodeGeneratorTests methodsFor:'tests'!

test_test_class_generated_for_metaclass
    | class |

    class := self classWithInstanceVariable
        category: 'Some-Category';
        yourself.

    self assertClassNotExists: class name.

    context selectedClasses: (Array with: class theMetaclass ).
    generatorOrRefactoring
        configureInContext: context;
        executeInContext: context.

    self assertClassExists: class name

    "Created: / 14-10-2014 / 10:42:20 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 05-11-2014 / 22:37:00 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_test_class_generated_with_package
    | class testClass |

    class := self classWithInstanceVariable
        category: 'Some-Category';
        package: #some_package_01;
        yourself.

    self assertClassNotExists: class name.

    context selectedClasses: (Array with: class theMetaclass ).

    generatorOrRefactoring
        configureInContext: context;
        executeInContext: context.

    self assert: generatorOrRefactoring samePackageAsTestedClass.  

    testClass := Smalltalk at: generatorOrRefactoring testClassName asSymbol.

    self assertClassExists: class name.
    self assert: (testClass package) = #some_package_01.

    "Created: / 15-11-2014 / 15:21:39 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_test_class_generated_without_package
    | class testClass |

    class := self classWithInstanceVariable
        category: 'Some-Category';
        package: #some_package_01;
        yourself.

    self assertClassNotExists: class name.

    context selectedClasses: (Array with: class theMetaclass ).

    generatorOrRefactoring
        configureInContext: context;
        samePackageAsTestedClass: false;
        executeInContext: context.

    testClass := Smalltalk at: generatorOrRefactoring testClassName asSymbol.

    self assertClassExists: class name.
    self deny: (testClass package) = #some_package_01.

    "Created: / 15-11-2014 / 15:37:59 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomTestCaseCodeGeneratorTests class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

